Index: branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/Histogram.cs
===================================================================
--- branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/Histogram.cs	(revision 5961)
+++ branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/Histogram.cs	(revision 5961)
@@ -0,0 +1,59 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis {
+  [Item("Histogram", "Holds data that is to be displayed as a histogram.")]
+  [StorableClass]
+  public class Histogram : NamedItem {
+
+    private ObservableCollection<double> values;
+    public ObservableCollection<double> Values {
+      get { return values; }
+    }
+
+    [Storable(Name = "values")]
+    private IEnumerable<double> StorableValues {
+      get { return values; }
+      set { values = new ObservableCollection<double>(value); }
+    }
+
+    [StorableConstructor]
+    protected Histogram(bool deserializing) : base(deserializing) { }
+    protected Histogram(Histogram original, Cloner cloner)
+      : base(original, cloner) {
+      this.values = new ObservableCollection<double>(original.values);
+    }
+    public Histogram()
+      : base() {
+      values = new ObservableCollection<double>();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Histogram(this, cloner);
+    }
+  }
+}
Index: branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/HistogramHistory.cs
===================================================================
--- branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/HistogramHistory.cs	(revision 5961)
+++ branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/HistogramHistory.cs	(revision 5961)
@@ -0,0 +1,49 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis {
+  /// <summary>
+  /// Represents history values of histograms.
+  /// </summary>
+  [Item("HistogramHistory", "Represents history values of histograms.")]
+  [StorableClass]
+  public class HistogramHistory : ItemCollection<Histogram> {
+    public override Image ItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Cab; }
+    }
+
+    [StorableConstructor]
+    protected HistogramHistory(bool deserializing) : base(deserializing) { }
+    protected HistogramHistory(HistogramHistory original, Cloner cloner) : base(original, cloner) { }
+    public HistogramHistory() : base() { }
+    public HistogramHistory(IEnumerable<Histogram> collection) : base(new ItemCollection<Histogram>(collection)) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new HistogramHistory(this, cloner);
+    }
+  }
+}
Index: branches/histogram/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj
===================================================================
--- branches/histogram/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj	(revision 5959)
+++ branches/histogram/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj	(revision 5961)
@@ -118,4 +118,5 @@
     <Compile Include="AlleleFrequencyAnalysis\AlleleFrequencyCollectionHistory.cs" />
     <Compile Include="BestScopeSolutionAnalyzer.cs" />
+    <Compile Include="DataVisualization\HistogramHistory.cs" />
     <Compile Include="DataVisualization\DataRow.cs" />
     <Compile Include="DataVisualization\DataRowVisualProperties.cs" />
@@ -126,4 +127,5 @@
     <Compile Include="DataVisualization\HeatMap.cs" />
     <Compile Include="DataVisualization\HeatMapHistory.cs" />
+    <Compile Include="DataVisualization\Histogram.cs" />
     <Compile Include="MultidimensionalScaling\MultidimensionalScaling.cs" />
     <Compile Include="MultiObjective\RankBasedParetoFrontAnalyzer.cs" />