Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.Designer.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.Designer.cs	(revision 5969)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.Designer.cs	(revision 5970)
@@ -45,12 +45,6 @@
     /// </summary>
     private void InitializeComponent() {
-      System.Windows.Forms.DataVisualization.Charting.ChartArea chartArea1 = new System.Windows.Forms.DataVisualization.Charting.ChartArea();
-      System.Windows.Forms.DataVisualization.Charting.Series series1 = new System.Windows.Forms.DataVisualization.Charting.Series();
-      this.enhancedChart = new HeuristicLab.Visualization.ChartControlsExtensions.EnhancedChart();
-      this.label1 = new System.Windows.Forms.Label();
-      this.numericUpDown = new System.Windows.Forms.NumericUpDown();
+      this.histogramControl = new HeuristicLab.Visualization.ChartControlsExtensions.HistogramControl();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-      ((System.ComponentModel.ISupportInitialize)(this.enhancedChart)).BeginInit();
-      ((System.ComponentModel.ISupportInitialize)(this.numericUpDown)).BeginInit();
       this.SuspendLayout();
       // 
@@ -66,45 +60,13 @@
       this.infoLabel.Location = new System.Drawing.Point(524, 3);
       // 
-      // enhancedChart
+      // histogramControl
       // 
-      this.enhancedChart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+      this.histogramControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      chartArea1.Name = "ChartArea1";
-      this.enhancedChart.ChartAreas.Add(chartArea1);
-      this.enhancedChart.Location = new System.Drawing.Point(0, 52);
-      this.enhancedChart.Name = "enhancedChart";
-      series1.ChartArea = "ChartArea1";
-      series1.Name = "Series1";
-      this.enhancedChart.Series.Add(series1);
-      this.enhancedChart.Size = new System.Drawing.Size(543, 320);
-      this.enhancedChart.TabIndex = 3;
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(3, 28);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(82, 13);
-      this.label1.TabIndex = 4;
-      this.label1.Text = "Number of Bins:";
-      // 
-      // numericUpDown
-      // 
-      this.numericUpDown.Location = new System.Drawing.Point(91, 26);
-      this.numericUpDown.Minimum = new decimal(new int[] {
-            1,
-            0,
-            0,
-            0});
-      this.numericUpDown.Name = "numericUpDown";
-      this.numericUpDown.Size = new System.Drawing.Size(61, 20);
-      this.numericUpDown.TabIndex = 5;
-      this.numericUpDown.Value = new decimal(new int[] {
-            10,
-            0,
-            0,
-            0});
-      this.numericUpDown.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
+      this.histogramControl.Location = new System.Drawing.Point(0, 26);
+      this.histogramControl.Name = "histogramControl";
+      this.histogramControl.Size = new System.Drawing.Size(543, 346);
+      this.histogramControl.TabIndex = 3;
       // 
       // HistogramView
@@ -112,18 +74,12 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.enhancedChart);
-      this.Controls.Add(this.numericUpDown);
-      this.Controls.Add(this.label1);
+      this.Controls.Add(this.histogramControl);
       this.Name = "HistogramView";
       this.Size = new System.Drawing.Size(543, 372);
-      this.Controls.SetChildIndex(this.label1, 0);
-      this.Controls.SetChildIndex(this.numericUpDown, 0);
-      this.Controls.SetChildIndex(this.enhancedChart, 0);
+      this.Controls.SetChildIndex(this.histogramControl, 0);
       this.Controls.SetChildIndex(this.nameLabel, 0);
       this.Controls.SetChildIndex(this.nameTextBox, 0);
       this.Controls.SetChildIndex(this.infoLabel, 0);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
-      ((System.ComponentModel.ISupportInitialize)(this.enhancedChart)).EndInit();
-      ((System.ComponentModel.ISupportInitialize)(this.numericUpDown)).EndInit();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -133,7 +89,6 @@
     #endregion
 
-    private Visualization.ChartControlsExtensions.EnhancedChart enhancedChart;
-    private System.Windows.Forms.Label label1;
-    private System.Windows.Forms.NumericUpDown numericUpDown;
+    private Visualization.ChartControlsExtensions.HistogramControl histogramControl;
+
   }
 }
Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.cs	(revision 5969)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.cs	(revision 5970)
@@ -20,8 +20,5 @@
 #endregion
 
-using System.Drawing;
-using System.Linq;
 using System.Windows.Forms;
-using System.Windows.Forms.DataVisualization.Charting;
 using HeuristicLab.Collections;
 using HeuristicLab.Core.Views;
@@ -59,11 +56,13 @@
     #region Event Handlers (Content)
     private void Content_Values_ItemsAdded(object sender, CollectionItemsChangedEventArgs<double> e) {
-      UpdateChartSettings();
+      histogramControl.AddPoints(e.Items);
     }
     private void Content_Values_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<double> e) {
-      InitializeChart();
+      histogramControl.ClearPoints();
+      histogramControl.AddPoints(Content.Values);
     }
     private void Content_Values_CollectionReset(object sender, CollectionItemsChangedEventArgs<double> e) {
-      InitializeChart();
+      histogramControl.ClearPoints();
+      histogramControl.AddPoints(Content.Values);
     }
     #endregion
@@ -72,74 +71,16 @@
       base.OnContentChanged();
       if (Content == null) {
-        enhancedChart.Series.Clear();
+        histogramControl.ClearPoints();
       } else {
-        InitializeChart();
+        histogramControl.AddPoints(Content.Values);
       }
     }
 
-    private void InitializeChart() {
-      enhancedChart.Series.Clear();
-      UpdateChartSettings();
-    }
-
-    private void UpdateChartSettings() {
-      if (Content == null || Content.Values.Count < 1) return;
-
-      int bins = (int)numericUpDown.Value;
-      string histogramSeriesName = "Histogram";
-
-      Series histogramSeries = null;
-      if (enhancedChart.Series.IndexOf(histogramSeriesName) < 0) {
-        histogramSeries = enhancedChart.Series.Add(histogramSeriesName);
-
-        histogramSeries.ChartType = SeriesChartType.Column;
-        histogramSeries.BorderColor = Color.Black;
-        histogramSeries.BorderWidth = 1;
-        histogramSeries.BorderDashStyle = ChartDashStyle.Solid;
-      } else {
-        histogramSeries = enhancedChart.Series[histogramSeriesName];
-        histogramSeries.Points.Clear();
-      }
-
-      double minValue = Content.Values.Min();
-      double maxValue = Content.Values.Max();
-      double intervalWidth = (maxValue - minValue) / bins;
-
-      double current = minValue;
-      int count = 0;
-      foreach (double v in Content.Values.OrderBy(x => x)) {
-        if (v < current + intervalWidth) {
-          count++;
-        } else {
-          histogramSeries.Points.AddXY(current + intervalWidth / 2.0, count);
-          count = 0;
-          current += intervalWidth;
-        }
-      }
-
-      histogramSeries["PointWidth"] = "1";
-
-      ChartArea chartArea = enhancedChart.ChartAreas[histogramSeries.ChartArea];
-      chartArea.AxisY.Title = "Frequency";
-      chartArea.AxisX.Minimum = minValue;
-      chartArea.AxisX.Maximum = maxValue;
-
-      double axisInterval = intervalWidth;
-      while ((maxValue - minValue) / axisInterval > 10.0) {
-        axisInterval *= 2.0;
-      }
-      chartArea.AxisX.Interval = axisInterval;
-    }
-
-
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
-      enhancedChart.Enabled = Content != null;
+      histogramControl.Enabled = Content != null;
     }
 
     #region Event Handlers (child controls)
-    private void numericUpDown_ValueChanged(object sender, System.EventArgs e) {
-      UpdateChartSettings();
-    }
     #endregion
   }
Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.resx
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.resx	(revision 5969)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.resx	(revision 5970)
@@ -121,7 +121,4 @@
     <value>107, 17</value>
   </metadata>
-  <metadata name="errorProvider.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
-    <value>107, 17</value>
-  </metadata>
   <metadata name="toolTip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
     <value>17, 17</value>
Index: /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HeuristicLab.Visualization.ChartControlsExtensions-3.3.csproj
===================================================================
--- /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HeuristicLab.Visualization.ChartControlsExtensions-3.3.csproj	(revision 5969)
+++ /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HeuristicLab.Visualization.ChartControlsExtensions-3.3.csproj	(revision 5970)
@@ -122,4 +122,10 @@
     </Compile>
     <Compile Include="HeuristicLabVisualizationChartControlsExtensionsPlugin.cs" />
+    <Compile Include="HistogramControl.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="HistogramControl.Designer.cs">
+      <DependentUpon>HistogramControl.cs</DependentUpon>
+    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
Index: /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HistogramControl.Designer.cs
===================================================================
--- /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HistogramControl.Designer.cs	(revision 5970)
+++ /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HistogramControl.Designer.cs	(revision 5970)
@@ -0,0 +1,140 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Visualization.ChartControlsExtensions {
+  partial class HistogramControl {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.Windows.Forms.DataVisualization.Charting.ChartArea chartArea1 = new System.Windows.Forms.DataVisualization.Charting.ChartArea();
+      System.Windows.Forms.DataVisualization.Charting.Series series1 = new System.Windows.Forms.DataVisualization.Charting.Series();
+      this.chart = new HeuristicLab.Visualization.ChartControlsExtensions.EnhancedChart();
+      this.binsNumericUpDown = new System.Windows.Forms.NumericUpDown();
+      this.label1 = new System.Windows.Forms.Label();
+      this.exactCheckBox = new System.Windows.Forms.CheckBox();
+      ((System.ComponentModel.ISupportInitialize)(this.chart)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.binsNumericUpDown)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // chart
+      // 
+      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      chartArea1.Name = "ChartArea1";
+      this.chart.ChartAreas.Add(chartArea1);
+      this.chart.Location = new System.Drawing.Point(0, 27);
+      this.chart.Name = "chart";
+      series1.ChartArea = "ChartArea1";
+      series1.Name = "Series1";
+      this.chart.Series.Add(series1);
+      this.chart.Size = new System.Drawing.Size(465, 336);
+      this.chart.TabIndex = 0;
+      // 
+      // binsNumericUpDown
+      // 
+      this.binsNumericUpDown.Location = new System.Drawing.Point(91, 3);
+      this.binsNumericUpDown.Maximum = new decimal(new int[] {
+            100000,
+            0,
+            0,
+            0});
+      this.binsNumericUpDown.Minimum = new decimal(new int[] {
+            1,
+            0,
+            0,
+            0});
+      this.binsNumericUpDown.Name = "binsNumericUpDown";
+      this.binsNumericUpDown.Size = new System.Drawing.Size(61, 20);
+      this.binsNumericUpDown.TabIndex = 1;
+      this.binsNumericUpDown.Value = new decimal(new int[] {
+            10,
+            0,
+            0,
+            0});
+      this.binsNumericUpDown.ValueChanged += new System.EventHandler(this.binsNumericUpDown_ValueChanged);
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(3, 5);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(82, 13);
+      this.label1.TabIndex = 2;
+      this.label1.Text = "Number of Bins:";
+      // 
+      // exactCheckBox
+      // 
+      this.exactCheckBox.AutoSize = true;
+      this.exactCheckBox.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
+      this.exactCheckBox.Location = new System.Drawing.Point(158, 4);
+      this.exactCheckBox.Name = "exactCheckBox";
+      this.exactCheckBox.Size = new System.Drawing.Size(56, 17);
+      this.exactCheckBox.TabIndex = 3;
+      this.exactCheckBox.Text = "Exact:";
+      this.exactCheckBox.UseVisualStyleBackColor = true;
+      this.exactCheckBox.CheckedChanged += new System.EventHandler(this.exactCheckBox_CheckedChanged);
+      // 
+      // HistogramControl
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.exactCheckBox);
+      this.Controls.Add(this.label1);
+      this.Controls.Add(this.binsNumericUpDown);
+      this.Controls.Add(this.chart);
+      this.Name = "HistogramControl";
+      this.Size = new System.Drawing.Size(465, 363);
+      ((System.ComponentModel.ISupportInitialize)(this.chart)).EndInit();
+      ((System.ComponentModel.ISupportInitialize)(this.binsNumericUpDown)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private EnhancedChart chart;
+    private System.Windows.Forms.NumericUpDown binsNumericUpDown;
+    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.CheckBox exactCheckBox;
+  }
+}
Index: /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HistogramControl.cs
===================================================================
--- /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HistogramControl.cs	(revision 5970)
+++ /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HistogramControl.cs	(revision 5970)
@@ -0,0 +1,130 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using System.Windows.Forms;
+using System.Windows.Forms.DataVisualization.Charting;
+
+namespace HeuristicLab.Visualization.ChartControlsExtensions {
+  public partial class HistogramControl : UserControl {
+    private static readonly string SeriesName = "Histogram";
+
+    private List<double> points;
+
+    public HistogramControl() {
+      InitializeComponent();
+      points = new List<double>();
+      InitializeChart();
+    }
+
+    public void AddPoint(double point) {
+      points.Add(point);
+      UpdateHistogram();
+    }
+
+    public void AddPoints(IEnumerable<double> points) {
+      this.points.AddRange(points);
+      UpdateHistogram();
+    }
+
+    public void ClearPoints() {
+      points.Clear();
+      UpdateHistogram();
+    }
+
+    private void InitializeChart() {
+      chart.Series.Clear();
+      Series s = chart.Series.Add(SeriesName);
+      s.ChartType = SeriesChartType.Column;
+      s.BorderColor = Color.Black;
+      s.BorderWidth = 1;
+      s.BorderDashStyle = ChartDashStyle.Solid;
+    }
+
+    private void UpdateHistogram() {
+
+      Series histogramSeries = chart.Series[SeriesName];
+      histogramSeries.Points.Clear();
+
+      if (!points.Any()) return;
+      int bins = (int)binsNumericUpDown.Value;
+
+      double minValue = points.Min();
+      double maxValue = points.Max();
+      double intervalWidth = (maxValue - minValue) / bins;
+      if (intervalWidth <= 0) return;
+
+      if (!exactCheckBox.Checked) {
+        intervalWidth = HumanRoundRange(intervalWidth);
+        minValue = Math.Floor(minValue / intervalWidth) * intervalWidth;
+        maxValue = Math.Ceiling(maxValue / intervalWidth) * intervalWidth;
+      }
+
+      double current = minValue;
+      int count = 0;
+      foreach (double v in points.OrderBy(x => x)) {
+        if (v < current + intervalWidth) {
+          count++;
+        } else {
+          histogramSeries.Points.AddXY(current + intervalWidth / 2.0, count);
+          count = 1;
+          while (v >= current + intervalWidth) current += intervalWidth;
+        }
+      }
+      histogramSeries.Points.AddXY(current + intervalWidth / 2.0, count);
+
+      histogramSeries["PointWidth"] = "1";
+
+      ChartArea chartArea = chart.ChartAreas[histogramSeries.ChartArea];
+      chartArea.AxisY.Title = "Frequency";
+      chartArea.AxisX.Minimum = minValue;
+      chartArea.AxisX.Maximum = maxValue;
+
+      double axisInterval = intervalWidth;
+      while ((maxValue - minValue) / axisInterval > 10.0) {
+        axisInterval *= 2.0;
+      }
+      chartArea.AxisX.Interval = axisInterval;
+    }
+
+    private double HumanRoundRange(double range) {
+      double base10 = Math.Pow(10.0, Math.Floor(Math.Log10(range)));
+      double rounding = range / base10;
+      if (rounding <= 1.5) rounding = 1;
+      else if (rounding <= 2) rounding = 2;
+      else if (rounding <= 2.5) rounding = 2.5;
+      else if (rounding <= 5) rounding = 5;
+      else rounding = 10;
+      return rounding * base10;
+    }
+
+    private void binsNumericUpDown_ValueChanged(object sender, EventArgs e) {
+      UpdateHistogram();
+    }
+
+    private void exactCheckBox_CheckedChanged(object sender, EventArgs e) {
+      UpdateHistogram();
+    }
+  }
+}