Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Controllers/AccountController.cs
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Controllers/AccountController.cs	(revision 5986)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Controllers/AccountController.cs	(revision 5988)
@@ -38,8 +38,10 @@
     public ActionResult LogOn(LogOnModel model, string returnUrl) {
       if (ModelState.IsValid) {
-        QueryServiceClient client = Query.GetClientFactory(model.UserName, model.Password);
-        if (client != null) {
-          Session["Username"] = model.UserName;
-          Session["Password"] = model.Password;
+        // QueryServiceClient client = Query.GetClientFactory(model.UserName, model.Password);
+
+
+
+        if (MembershipService.ValidateUser(model.UserName, model.Password)) {
+
           FormsService.SignIn(model.UserName, model.RememberMe);
           if (!String.IsNullOrEmpty(returnUrl)) {
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/HLWebPluginHost.csproj
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/HLWebPluginHost.csproj	(revision 5986)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/HLWebPluginHost.csproj	(revision 5988)
@@ -1,3 +1,3 @@
-<?xml version="1.0" encoding="utf-8"?>
+﻿<?xml version="1.0" encoding="utf-8"?>
 <Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <PropertyGroup>
@@ -73,5 +73,4 @@
       <DependentUpon>Global.asax</DependentUpon>
     </Compile>
-
     <Compile Include="Lib\HLServiceMembershipProvider.cs" />
     <Compile Include="Helpers\Query.cs" />
@@ -83,9 +82,4 @@
     <Compile Include="PluginLib\PluginViewEngine.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="Service References\OKBQueryService\Reference.cs">
-      <AutoGen>True</AutoGen>
-      <DesignTime>True</DesignTime>
-      <DependentUpon>Reference.svcmap</DependentUpon>
-    </Compile>
   </ItemGroup>
   <ItemGroup>
@@ -98,17 +92,4 @@
     <Content Include="Global.asax" />
     <Content Include="Scripts\lbAlgorithmClassOnClick.js" />
-    <None Include="Service References\OKBQueryService\HLWebPluginHost.OKBQueryService.Filter.datasource">
-      <DependentUpon>Reference.svcmap</DependentUpon>
-    </None>
-    <None Include="Service References\OKBQueryService\HLWebPluginHost.OKBQueryService.Run.datasource">
-      <DependentUpon>Reference.svcmap</DependentUpon>
-    </None>
-    <None Include="Service References\OKBQueryService\QueryService.disco" />
-    <None Include="Service References\OKBQueryService\configuration91.svcinfo" />
-    <None Include="Service References\OKBQueryService\configuration.svcinfo" />
-    <None Include="Service References\OKBQueryService\Reference.svcmap">
-      <Generator>WCF Proxy Generator</Generator>
-      <LastGenOutput>Reference.cs</LastGenOutput>
-    </None>
     <Content Include="Views\ServicePrototype\Index.aspx" />
     <Content Include="Web.config">
@@ -153,22 +134,4 @@
     <WCFMetadata Include="Service References\" />
   </ItemGroup>
-  <ItemGroup>
-    <WCFMetadataStorage Include="Service References\OKBQueryService\" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Service References\OKBQueryService\QueryService.wsdl" />
-    <None Include="Service References\OKBQueryService\QueryService.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\OKBQueryService\QueryService1.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\OKBQueryService\QueryService2.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\OKBQueryService\QueryService3.xsd">
-      <SubType>Designer</SubType>
-    </None>
-  </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
   <Import Project="$(MSBuildExtensionsPath32)\Microsoft\VisualStudio\v10.0\WebApplications\Microsoft.WebApplication.targets" />
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Lib/HLServiceMembershipProvider.cs
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Lib/HLServiceMembershipProvider.cs	(revision 5986)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Lib/HLServiceMembershipProvider.cs	(revision 5988)
@@ -119,5 +119,7 @@
       // TODO: Add authentication against the HL-Service as soon as it's available.
       try {
+
         HttpContext.Current.Session["Password"] = password;
+
         return true;
       } catch (Exception) {
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/Home/Index.aspx
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/Home/Index.aspx	(revision 5986)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/Home/Index.aspx	(revision 5988)
@@ -6,7 +6,4 @@
 
 <asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
-    <h1><%: ViewData["Message"] %></h1>
 
-    <h3>Username: <%: Session["Username"]  %></h3>
-    <h3>Password: <%: Session["Password"]  %></h3>
 </asp:Content>
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Web.config
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Web.config	(revision 5986)
+++ branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Web.config	(revision 5988)
@@ -60,5 +60,5 @@
     </pages>
   
-        <!--<membership defaultProvider="HLServiceMembershipProvider">
+        <membership defaultProvider="HLServiceMembershipProvider">
             <providers>
               <clear/>
@@ -69,5 +69,5 @@
                    applicationName="HeuristicLab.Authentication" />
             </providers>
-          </membership>-->
+          </membership>
 <!--
           <roleManager enabled="true">
@@ -116,20 +116,4 @@
           </security>
         </binding>
-        <binding name="QueryService" closeTimeout="00:01:00" openTimeout="00:01:00"
-          receiveTimeout="00:10:00" sendTimeout="00:01:00" bypassProxyOnLocal="false"
-          transactionFlow="false" hostNameComparisonMode="StrongWildcard"
-          maxBufferPoolSize="524288" maxReceivedMessageSize="65536" messageEncoding="Text"
-          textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
-          <readerQuotas maxDepth="32" maxStringContentLength="8192" maxArrayLength="16384"
-            maxBytesPerRead="4096" maxNameTableCharCount="16384" />
-          <reliableSession ordered="true" inactivityTimeout="00:10:00"
-            enabled="false" />
-          <security mode="Message">
-            <transport clientCredentialType="Windows" proxyCredentialType="None"
-              realm="" />
-            <message clientCredentialType="UserName" negotiateServiceCredential="true"
-              algorithmSuite="Default" />
-          </security>
-        </binding>
       </wsHttpBinding>
     </bindings>
@@ -142,11 +126,4 @@
         </identity>
       </endpoint>
-      <endpoint address="http://services.heuristiclab.com/OKB.SPR-3.3/QueryService.svc"
-        binding="wsHttpBinding" bindingConfiguration="QueryService"
-        contract="OKBQueryService.IQueryService" name="QueryService">
-        <identity>
-          <certificate encodedValue="AwAAAAEAAAAUAAAAwK1+2oAmcy/mI2P2QjyiJRh0y60gAAAAAQAAACoCAAAwggImMIIBj6ADAgECAhAIkseQ2EEhgU720qJA61gqMA0GCSqGSIb3DQEBBAUAMCQxIjAgBgNVBAMTGXNlcnZpY2VzLmhldXJpc3RpY2xhYi5jb20wHhcNMTAwNTExMTExNDAyWhcNMzkxMjMxMjM1OTU5WjAkMSIwIAYDVQQDExlzZXJ2aWNlcy5oZXVyaXN0aWNsYWIuY29tMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCq26Bwmwc7k+4W30qLQ2j+FInEL5BuH6opDY6CSlrtt3xQS/anrhvpbf3QghLDVINzcHkzbPmm/SguG4F85QLB6xO+tJaOvRo0iEK5g3c307vMIru7FJwk/OhplEQ5J1hbDgL3zOJlrWlgtqRVxCtVdF3XroI9BctOt1NkeKv9ewIDAQABo1kwVzBVBgNVHQEETjBMgBCjbgdYd4j5JgUuJ1Wo/GxroSYwJDEiMCAGA1UEAxMZc2VydmljZXMuaGV1cmlzdGljbGFiLmNvbYIQCJLHkNhBIYFO9tKiQOtYKjANBgkqhkiG9w0BAQQFAAOBgQAb/2xk2uQad68shSPl/uixWgvFI8WkxOTBopOLaLtDxwCeZ3mWVHdV9VnixHtThubnEBXAhYOCQSIXWtQuXFWO+gH3YyjTRJY5kTmXyuvBRTn3/so5SrQ7Rdlm9hf6E5YVX3tCjAy7ybUyaDUkQfmH5vmvgvpMzRfsJ1qhnUpJiQ==" />
-        </identity>
-      </endpoint>
     </client>
   </system.serviceModel>