Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.Designer.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.Designer.cs	(revision 5994)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.Designer.cs	(revision 5994)
@@ -0,0 +1,78 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Analysis.Views {
+  partial class AggregatedHistogramHistoryView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.histogramControl = new HeuristicLab.Visualization.ChartControlsExtensions.HistogramControl();
+      this.SuspendLayout();
+      // 
+      // histogramControl
+      // 
+      this.histogramControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.histogramControl.Location = new System.Drawing.Point(0, 26);
+      this.histogramControl.Name = "histogramControl";
+      this.histogramControl.Size = new System.Drawing.Size(543, 346);
+      this.histogramControl.TabIndex = 3;
+      // 
+      // HistogramView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.histogramControl);
+      this.Name = "HistogramView";
+      this.Size = new System.Drawing.Size(543, 372);
+      this.Controls.SetChildIndex(this.histogramControl, 0);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private Visualization.ChartControlsExtensions.HistogramControl histogramControl;
+
+  }
+}
Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.cs	(revision 5994)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.cs	(revision 5994)
@@ -0,0 +1,132 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Collections;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.Analysis.Views {
+  [View("Aggregated Histogram History View")]
+  [Content(typeof(HistogramHistory), IsDefaultView = false)]
+  public partial class AggregatedHistogramHistoryView : ItemView {
+
+    public new HistogramHistory Content {
+      get { return (HistogramHistory)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public AggregatedHistogramHistoryView() {
+      InitializeComponent();
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.ItemsAdded -= new CollectionItemsChangedEventHandler<Histogram>(Content_ItemsAdded);
+      Content.ItemsRemoved -= new CollectionItemsChangedEventHandler<Histogram>(Content_ItemsRemoved);
+      Content.CollectionReset -= new CollectionItemsChangedEventHandler<Histogram>(Content_CollectionReset);
+      foreach (Histogram h in Content) {
+        DeregisterHistogramEvents(h);
+      }
+      base.DeregisterContentEvents();
+    }
+
+    private void DeregisterHistogramEvents(Histogram histogram) {
+      histogram.Values.ItemsAdded -= new CollectionItemsChangedEventHandler<double>(Content_Values_ItemsAdded);
+      histogram.Values.ItemsRemoved -= new CollectionItemsChangedEventHandler<double>(Content_Values_ItemsRemoved);
+      histogram.Values.CollectionReset -= new CollectionItemsChangedEventHandler<double>(Content_Values_CollectionReset);
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ItemsAdded += new CollectionItemsChangedEventHandler<Histogram>(Content_ItemsAdded);
+      Content.ItemsRemoved += new CollectionItemsChangedEventHandler<Histogram>(Content_ItemsRemoved);
+      Content.CollectionReset += new CollectionItemsChangedEventHandler<Histogram>(Content_CollectionReset);
+      foreach (Histogram h in Content) {
+        RegisterHistogramEvents(h);
+      }
+    }
+
+    protected virtual void RegisterHistogramEvents(Histogram histogram) {
+      histogram.Values.ItemsAdded += new CollectionItemsChangedEventHandler<double>(Content_Values_ItemsAdded);
+      histogram.Values.ItemsRemoved += new CollectionItemsChangedEventHandler<double>(Content_Values_ItemsRemoved);
+      histogram.Values.CollectionReset += new CollectionItemsChangedEventHandler<double>(Content_Values_CollectionReset);
+    }
+
+    #region Event Handlers (Content)
+    private void Content_Values_ItemsAdded(object sender, CollectionItemsChangedEventArgs<double> e) {
+      histogramControl.AddPoints(e.Items);
+    }
+    private void Content_Values_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<double> e) {
+      InitializeHistogram();
+    }
+    private void Content_Values_CollectionReset(object sender, CollectionItemsChangedEventArgs<double> e) {
+      InitializeHistogram();
+    }
+    private void Content_ItemsAdded(object sender, CollectionItemsChangedEventArgs<Histogram> e) {
+      List<double> added = new List<double>();
+      foreach (Histogram h in e.Items) {
+        RegisterHistogramEvents(h);
+        added.AddRange(h.Values);
+      }
+      histogramControl.AddPoints(added);
+    }
+    private void Content_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<Histogram> e) {
+      foreach (Histogram h in e.Items) {
+        DeregisterHistogramEvents(h);
+      }
+      InitializeHistogram();
+    }
+    private void Content_CollectionReset(object sender, CollectionItemsChangedEventArgs<Histogram> e) {
+      foreach (Histogram h in e.OldItems) {
+        DeregisterHistogramEvents(h);
+      }
+      InitializeHistogram();
+    }
+    #endregion
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        histogramControl.ClearPoints();
+      } else {
+        InitializeHistogram();
+      }
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      histogramControl.Enabled = Content != null;
+    }
+
+    private void InitializeHistogram() {
+      if (Content == null) return;
+      histogramControl.ClearPoints();
+      var points = Content.SelectMany(x => x.Values);
+      histogramControl.AddPoints(points);
+    }
+
+    #region Event Handlers (child controls)
+    #endregion
+  }
+}
Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.resx
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.resx	(revision 5994)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.resx	(revision 5994)
@@ -0,0 +1,126 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <metadata name="errorProvider.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>107, 17</value>
+  </metadata>
+  <metadata name="toolTip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>17, 17</value>
+  </metadata>
+</root>
Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj	(revision 5993)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj	(revision 5994)
@@ -124,4 +124,16 @@
       <DependentUpon>AlleleFrequencyCollectionView.cs</DependentUpon>
     </Compile>
+    <Compile Include="AggregatedHistogramHistoryView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="AggregatedHistogramHistoryView.Designer.cs">
+      <DependentUpon>AggregatedHistogramHistoryView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="HistogramHistoryView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="HistogramHistoryView.Designer.cs">
+      <DependentUpon>HistogramHistoryView.cs</DependentUpon>
+    </Compile>
     <Compile Include="HeatMapHistoryView.cs">
       <SubType>UserControl</SubType>
@@ -237,4 +249,7 @@
   </ItemGroup>
   <ItemGroup>
+    <EmbeddedResource Include="AggregatedHistogramHistoryView.resx">
+      <DependentUpon>AggregatedHistogramHistoryView.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="HeatMapView.resx">
       <DependentUpon>HeatMapView.cs</DependentUpon>
Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramHistoryView.Designer.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramHistoryView.Designer.cs	(revision 5994)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramHistoryView.Designer.cs	(revision 5994)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Analysis.Views {
+  partial class HistogramHistoryView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramHistoryView.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramHistoryView.cs	(revision 5994)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramHistoryView.cs	(revision 5994)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Analysis.Views {
+  [View("Histogram History View")]
+  [Content(typeof(HistogramHistory), true)]
+  public partial class HistogramHistoryView : MovieView<Histogram> {
+    public HistogramHistoryView() {
+      InitializeComponent();
+      itemsGroupBox.Text = "Histogram";
+    }
+  }
+}
Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.cs	(revision 5993)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/HistogramView.cs	(revision 5994)
@@ -29,5 +29,5 @@
   [View("Histogram View")]
   [Content(typeof(Histogram), IsDefaultView = true)]
-  public sealed partial class HistogramView : NamedItemView {
+  public partial class HistogramView : NamedItemView {
 
     public new Histogram Content {
@@ -70,7 +70,6 @@
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      if (Content == null) {
-        histogramControl.ClearPoints();
-      } else {
+      histogramControl.ClearPoints();
+      if (Content != null) {
         histogramControl.AddPoints(Content.Values);
       }
Index: /branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/Histogram.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/Histogram.cs	(revision 5993)
+++ /branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/Histogram.cs	(revision 5994)
@@ -52,4 +52,12 @@
       values = new ObservableCollection<double>();
     }
+    public Histogram(string name)
+      : base(name) {
+      values = new ObservableCollection<double>();
+    }
+    public Histogram(string name, string description)
+      : base(description) {
+      values = new ObservableCollection<double>();
+    }
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: /branches/histogram/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj
===================================================================
--- /branches/histogram/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj	(revision 5993)
+++ /branches/histogram/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj	(revision 5994)
@@ -140,4 +140,5 @@
     <Compile Include="HeuristicLabAnalysisPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="QualityAnalysis\QualityDistributionAnalyzer.cs" />
     <Compile Include="ValueAnalysis\MinAverageMaxValueAnalyzer.cs" />
     <Compile Include="ValueAnalysis\MinAverageMaxValueCalculator.cs" />
Index: /branches/histogram/HeuristicLab.Analysis/3.3/QualityAnalysis/QualityDistributionAnalyzer.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis/3.3/QualityAnalysis/QualityDistributionAnalyzer.cs	(revision 5994)
+++ /branches/histogram/HeuristicLab.Analysis/3.3/QualityAnalysis/QualityDistributionAnalyzer.cs	(revision 5994)
@@ -0,0 +1,84 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis.QualityAnalysis {
+  [Item("Quality Distribution Analyzer", "Analyzes the distribution of the quality values in that it adds a Histogram of them into the result collection.")]
+  [StorableClass]
+  public class QualityDistributionAnalyzer : SingleSuccessorOperator, IAnalyzer {
+
+    #region Parameter properties
+    public IScopeTreeLookupParameter<DoubleValue> QualityParameter {
+      get { return (IScopeTreeLookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+    public IValueLookupParameter<ResultCollection> ResultsParameter {
+      get { return (IValueLookupParameter<ResultCollection>)Parameters["Results"]; }
+    }
+    public IValueParameter<StringValue> HistogramNameParameter {
+      get { return (IValueParameter<StringValue>)Parameters["HistogramName"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected QualityDistributionAnalyzer(bool deserializing) : base(deserializing) { }
+    protected QualityDistributionAnalyzer(QualityDistributionAnalyzer original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public QualityDistributionAnalyzer()
+      : base() {
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The value which represents the quality of a solution."));
+      Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The results collection where the analysis values should be stored."));
+      Parameters.Add(new ValueParameter<StringValue>("HistogramName", "The name of the histogram that gets injected in to the results collection.", new StringValue("QualityDistribution")));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new QualityDistributionAnalyzer(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      HistogramHistory qualityDistribution = null;
+      ResultCollection results = ResultsParameter.ActualValue;
+      string description = "Shows the quality distributions in the current population.";
+      string resultName = HistogramNameParameter.Value.Value;
+      if (results.ContainsKey(resultName)) {
+        qualityDistribution = results[resultName].Value as HistogramHistory;
+      } else {
+        qualityDistribution = new HistogramHistory();
+        results.Add(new Result(resultName, description, qualityDistribution));
+      }
+      Histogram histogram = new Histogram("History " + qualityDistribution.Count, description);
+      var qualities = QualityParameter.ActualValue;
+      histogram.Values.Clear();
+      histogram.Values.AddRange(qualities.Select(x => x.Value));
+      qualityDistribution.Add(histogram);
+
+      return base.Apply();
+    }
+  }
+}
Index: /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HistogramControl.cs
===================================================================
--- /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HistogramControl.cs	(revision 5993)
+++ /branches/histogram/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HistogramControl.cs	(revision 5994)
@@ -32,4 +32,33 @@
 
     private List<double> points;
+    public int NumberOfBins {
+      get { return (int)binsNumericUpDown.Value; }
+      set { binsNumericUpDown.Value = value; }
+    }
+
+    public int MinimumNumberOfBins {
+      get { return (int)binsNumericUpDown.Minimum; }
+      set { binsNumericUpDown.Minimum = value; }
+    }
+
+    public int MaximumNumberOfBins {
+      get { return (int)binsNumericUpDown.Maximum; }
+      set { binsNumericUpDown.Maximum = value; }
+    }
+
+    public int IncrementNumberOfBins {
+      get { return (int)binsNumericUpDown.Increment; }
+      set { binsNumericUpDown.Increment = value; }
+    }
+
+    public bool CalculateExactBins {
+      get { return exactCheckBox.Checked; }
+      set { exactCheckBox.Checked = value; }
+    }
+
+    public bool ShowExactCheckbox {
+      get { return exactCheckBox.Visible; }
+      set { exactCheckBox.Visible = value; }
+    }
 
     public HistogramControl() {
@@ -64,5 +93,8 @@
 
     private void UpdateHistogram() {
-
+      if (InvokeRequired) {
+        Invoke((Action)UpdateHistogram, null);
+        return;
+      }
       Series histogramSeries = chart.Series[SeriesName];
       histogramSeries.Points.Clear();
@@ -113,7 +145,7 @@
       double rounding = range / base10;
       if (rounding <= 1.5) rounding = 1;
-      else if (rounding <= 2) rounding = 2;
-      else if (rounding <= 2.5) rounding = 2.5;
-      else if (rounding <= 5) rounding = 5;
+      else if (rounding <= 2.25) rounding = 2;
+      else if (rounding <= 3.75) rounding = 2.5;
+      else if (rounding <= 7.5) rounding = 5;
       else rounding = 10;
       return rounding * base10;