Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.Designer.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.Designer.cs	(revision 5994)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.Designer.cs	(revision 5995)
@@ -50,22 +50,24 @@
       // histogramControl
       // 
-      this.histogramControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.histogramControl.Location = new System.Drawing.Point(0, 26);
+      this.histogramControl.CalculateExactBins = false;
+      this.histogramControl.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.histogramControl.IncrementNumberOfBins = 1;
+      this.histogramControl.Location = new System.Drawing.Point(0, 0);
+      this.histogramControl.MaximumNumberOfBins = 100000;
+      this.histogramControl.MinimumNumberOfBins = 1;
       this.histogramControl.Name = "histogramControl";
-      this.histogramControl.Size = new System.Drawing.Size(543, 346);
+      this.histogramControl.NumberOfBins = 10;
+      this.histogramControl.ShowExactCheckbox = true;
+      this.histogramControl.Size = new System.Drawing.Size(543, 372);
       this.histogramControl.TabIndex = 3;
       // 
-      // HistogramView
+      // AggregatedHistogramHistoryView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Controls.Add(this.histogramControl);
-      this.Name = "HistogramView";
+      this.Name = "AggregatedHistogramHistoryView";
       this.Size = new System.Drawing.Size(543, 372);
-      this.Controls.SetChildIndex(this.histogramControl, 0);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.cs	(revision 5994)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.cs	(revision 5995)
@@ -43,7 +43,8 @@
 
     protected override void DeregisterContentEvents() {
-      Content.ItemsAdded -= new CollectionItemsChangedEventHandler<Histogram>(Content_ItemsAdded);
-      Content.ItemsRemoved -= new CollectionItemsChangedEventHandler<Histogram>(Content_ItemsRemoved);
-      Content.CollectionReset -= new CollectionItemsChangedEventHandler<Histogram>(Content_CollectionReset);
+      Content.ItemsAdded -= new CollectionItemsChangedEventHandler<IndexedItem<Histogram>>(Content_ItemsAdded);
+      Content.ItemsRemoved -= new CollectionItemsChangedEventHandler<IndexedItem<Histogram>>(Content_ItemsRemoved);
+      Content.CollectionReset -= new CollectionItemsChangedEventHandler<IndexedItem<Histogram>>(Content_CollectionReset);
+      Content.CheckedItemsChanged -= new CollectionItemsChangedEventHandler<IndexedItem<Histogram>>(Content_CheckedItemsChanged);
       foreach (Histogram h in Content) {
         DeregisterHistogramEvents(h);
@@ -60,7 +61,8 @@
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
-      Content.ItemsAdded += new CollectionItemsChangedEventHandler<Histogram>(Content_ItemsAdded);
-      Content.ItemsRemoved += new CollectionItemsChangedEventHandler<Histogram>(Content_ItemsRemoved);
-      Content.CollectionReset += new CollectionItemsChangedEventHandler<Histogram>(Content_CollectionReset);
+      Content.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<Histogram>>(Content_ItemsAdded);
+      Content.ItemsRemoved += new CollectionItemsChangedEventHandler<IndexedItem<Histogram>>(Content_ItemsRemoved);
+      Content.CollectionReset += new CollectionItemsChangedEventHandler<IndexedItem<Histogram>>(Content_CollectionReset);
+      Content.CheckedItemsChanged += new CollectionItemsChangedEventHandler<IndexedItem<Histogram>>(Content_CheckedItemsChanged);
       foreach (Histogram h in Content) {
         RegisterHistogramEvents(h);
@@ -84,21 +86,24 @@
       InitializeHistogram();
     }
-    private void Content_ItemsAdded(object sender, CollectionItemsChangedEventArgs<Histogram> e) {
+    private void Content_CheckedItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<Histogram>> e) {
+      InitializeHistogram();
+    }
+    private void Content_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<Histogram>> e) {
       List<double> added = new List<double>();
-      foreach (Histogram h in e.Items) {
-        RegisterHistogramEvents(h);
-        added.AddRange(h.Values);
+      foreach (IndexedItem<Histogram> h in e.Items) {
+        RegisterHistogramEvents(h.Value);
+        added.AddRange(h.Value.Values);
       }
       histogramControl.AddPoints(added);
     }
-    private void Content_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<Histogram> e) {
-      foreach (Histogram h in e.Items) {
-        DeregisterHistogramEvents(h);
+    private void Content_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<Histogram>> e) {
+      foreach (IndexedItem<Histogram> h in e.Items) {
+        DeregisterHistogramEvents(h.Value);
       }
       InitializeHistogram();
     }
-    private void Content_CollectionReset(object sender, CollectionItemsChangedEventArgs<Histogram> e) {
-      foreach (Histogram h in e.OldItems) {
-        DeregisterHistogramEvents(h);
+    private void Content_CollectionReset(object sender, CollectionItemsChangedEventArgs<IndexedItem<Histogram>> e) {
+      foreach (IndexedItem<Histogram> h in e.OldItems) {
+        DeregisterHistogramEvents(h.Value);
       }
       InitializeHistogram();
@@ -123,5 +128,5 @@
       if (Content == null) return;
       histogramControl.ClearPoints();
-      var points = Content.SelectMany(x => x.Values);
+      var points = Content.CheckedItems.SelectMany(x => x.Value.Values);
       histogramControl.AddPoints(points);
     }
Index: /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.resx
===================================================================
--- /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.resx	(revision 5994)
+++ /branches/histogram/HeuristicLab.Analysis.Views/3.3/AggregatedHistogramHistoryView.resx	(revision 5995)
@@ -118,9 +118,3 @@
     <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
-  <metadata name="errorProvider.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
-    <value>107, 17</value>
-  </metadata>
-  <metadata name="toolTip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
-    <value>17, 17</value>
-  </metadata>
 </root>
Index: /branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/HistogramHistory.cs
===================================================================
--- /branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/HistogramHistory.cs	(revision 5994)
+++ /branches/histogram/HeuristicLab.Analysis/3.3/DataVisualization/HistogramHistory.cs	(revision 5995)
@@ -32,5 +32,5 @@
   [Item("HistogramHistory", "Represents history values of histograms.")]
   [StorableClass]
-  public class HistogramHistory : ItemCollection<Histogram> {
+  public class HistogramHistory : CheckedItemList<Histogram> {
     public override Image ItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Cab; }
@@ -41,5 +41,5 @@
     protected HistogramHistory(HistogramHistory original, Cloner cloner) : base(original, cloner) { }
     public HistogramHistory() : base() { }
-    public HistogramHistory(IEnumerable<Histogram> collection) : base(new ItemCollection<Histogram>(collection)) { }
+    public HistogramHistory(IEnumerable<Histogram> collection) : base(collection) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {