Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/ErrorHandling/FrameworkVersionErrorDialog.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/ErrorHandling/FrameworkVersionErrorDialog.Designer.cs	(revision 5997)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/3.3/ErrorHandling/FrameworkVersionErrorDialog.Designer.cs	(revision 5997)
@@ -0,0 +1,130 @@
+﻿#region License Information
+/* HeuristicLab
+* Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+*
+* This file is part of HeuristicLab.
+*
+* HeuristicLab is free software: you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.PluginInfrastructure {
+  partial class FrameworkVersionErrorDialog {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.iconLabel = new System.Windows.Forms.Label();
+      this.closeButton = new System.Windows.Forms.Button();
+      this.linkLabel = new System.Windows.Forms.LinkLabel();
+      this.label = new System.Windows.Forms.Label();
+      this.SuspendLayout();
+      // 
+      // iconLabel
+      // 
+      this.iconLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)));
+      this.iconLabel.Image = global::HeuristicLab.PluginInfrastructure.Resources.Error;
+      this.iconLabel.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
+      this.iconLabel.Location = new System.Drawing.Point(12, 9);
+      this.iconLabel.Name = "iconLabel";
+      this.iconLabel.Size = new System.Drawing.Size(50, 98);
+      this.iconLabel.TabIndex = 0;
+      // 
+      // closeButton
+      // 
+      this.closeButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.closeButton.DialogResult = System.Windows.Forms.DialogResult.OK;
+      this.closeButton.Location = new System.Drawing.Point(294, 81);
+      this.closeButton.Name = "closeButton";
+      this.closeButton.Size = new System.Drawing.Size(75, 23);
+      this.closeButton.TabIndex = 3;
+      this.closeButton.Text = "&Close";
+      this.closeButton.UseVisualStyleBackColor = true;
+      this.closeButton.Click += new System.EventHandler(this.cancelButton_Click);
+      // 
+      // linkLabel
+      // 
+      this.linkLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.linkLabel.Location = new System.Drawing.Point(68, 52);
+      this.linkLabel.Name = "linkLabel";
+      this.linkLabel.Size = new System.Drawing.Size(301, 26);
+      this.linkLabel.TabIndex = 2;
+      this.linkLabel.TabStop = true;
+      this.linkLabel.Text = "Download Microsoft .NET Framework 4 (Full Profile)";
+      this.linkLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel_LinkClicked);
+      // 
+      // label
+      // 
+      this.label.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.label.Location = new System.Drawing.Point(68, 9);
+      this.label.Name = "label";
+      this.label.Size = new System.Drawing.Size(301, 43);
+      this.label.TabIndex = 1;
+      this.label.Text = "The Microsoft .NET Framework 4 (Full Profile) is not properly installed on your s" +
+          "ystem. Please download and install it.";
+      // 
+      // FrameworkVersionErrorDialog
+      // 
+      this.AcceptButton = this.closeButton;
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.CancelButton = this.closeButton;
+      this.ClientSize = new System.Drawing.Size(381, 116);
+      this.Controls.Add(this.label);
+      this.Controls.Add(this.linkLabel);
+      this.Controls.Add(this.closeButton);
+      this.Controls.Add(this.iconLabel);
+      this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
+      this.Icon = global::HeuristicLab.PluginInfrastructure.Resources.HeuristicLab;
+      this.MaximizeBox = false;
+      this.MinimizeBox = false;
+      this.Name = "FrameworkVersionErrorDialog";
+      this.ShowInTaskbar = false;
+      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
+      this.Text = "Error";
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label iconLabel;
+    private System.Windows.Forms.Button closeButton;
+    private System.Windows.Forms.LinkLabel linkLabel;
+    private System.Windows.Forms.Label label;
+  }
+}
Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/ErrorHandling/FrameworkVersionErrorDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/ErrorHandling/FrameworkVersionErrorDialog.cs	(revision 5997)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/3.3/ErrorHandling/FrameworkVersionErrorDialog.cs	(revision 5997)
@@ -0,0 +1,47 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+	 * (at your option) any later version.
+	 *
+	 * HeuristicLab is distributed in the hope that it will be useful,
+	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
+	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+	 * GNU General Public License for more details.
+	 *
+	 * You should have received a copy of the GNU General Public License
+	 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+	 */
+#endregion
+
+using System;
+using System.Windows.Forms;
+
+namespace HeuristicLab.PluginInfrastructure {
+  public partial class FrameworkVersionErrorDialog : Form {
+    public static bool NET4FullProfileInstalled {
+      get { return Microsoft.Win32.Registry.LocalMachine.OpenSubKey("Software\\Microsoft\\NET Framework Setup\\NDP\\v4\\Full") != null; }
+    }
+
+    public FrameworkVersionErrorDialog() {
+      InitializeComponent();
+    }
+
+    private void linkLabel_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e) {
+      try {
+        System.Diagnostics.Process.Start("http://www.microsoft.com/downloads/en/details.aspx?displaylang=en&FamilyID=0a391abd-25c1-4fc0-919f-b21f31ab88b7");
+        linkLabel.LinkVisited = true;
+      }
+      catch (Exception) { }
+    }
+
+    private void cancelButton_Click(object sender, EventArgs e) {
+      Application.Exit();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/ErrorHandling/FrameworkVersionWarning.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/ErrorHandling/FrameworkVersionWarning.Designer.cs	(revision 5984)
+++ 	(revision )
@@ -1,123 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
-* Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
-*
-* This file is part of HeuristicLab.
-*
-* HeuristicLab is free software: you can redistribute it and/or modify
-* it under the terms of the GNU General Public License as published by
-* the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-namespace HeuristicLab.PluginInfrastructure {
-  partial class FrameworkVersionWarning {
-    /// <summary>
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary>
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Windows Form Designer generated code
-
-    /// <summary>
-    /// Required method for Designer support - do not modify
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.iconLabel = new System.Windows.Forms.Label();
-      this.okButton = new System.Windows.Forms.Button();
-      this.linkLabel = new System.Windows.Forms.LinkLabel();
-      this.label1 = new System.Windows.Forms.Label();
-      this.SuspendLayout();
-      // 
-      // iconLabel
-      // 
-      this.iconLabel.Image = global::HeuristicLab.PluginInfrastructure.Resources.Error;
-      this.iconLabel.Location = new System.Drawing.Point(12, 9);
-      this.iconLabel.Name = "iconLabel";
-      this.iconLabel.Size = new System.Drawing.Size(21, 22);
-      this.iconLabel.TabIndex = 1;
-      // 
-      // okButton
-      // 
-      this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
-      this.okButton.Location = new System.Drawing.Point(206, 102);
-      this.okButton.Name = "okButton";
-      this.okButton.Size = new System.Drawing.Size(75, 23);
-      this.okButton.TabIndex = 6;
-      this.okButton.Text = "&Close";
-      this.okButton.UseVisualStyleBackColor = true;
-      this.okButton.Click += new System.EventHandler(this.cancelButton_Click);
-      // 
-      // linkLabel
-      // 
-      this.linkLabel.AutoSize = true;
-      this.linkLabel.Location = new System.Drawing.Point(39, 66);
-      this.linkLabel.Name = "linkLabel";
-      this.linkLabel.Size = new System.Drawing.Size(210, 13);
-      this.linkLabel.TabIndex = 9;
-      this.linkLabel.TabStop = true;
-      this.linkLabel.Text = ".NET framework v4.0 (full profile) download";
-      this.linkLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel_LinkClicked);
-      // 
-      // label1
-      // 
-      this.label1.Location = new System.Drawing.Point(39, 9);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(255, 33);
-      this.label1.TabIndex = 10;
-      this.label1.Text = ".NET framework version 4.0 (full profile) is not properly installed. Please downl" +
-          "oad and install it.";
-      // 
-      // FrameworkVersionWarning
-      // 
-      this.AcceptButton = this.okButton;
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.CancelButton = this.okButton;
-      this.ClientSize = new System.Drawing.Size(293, 137);
-      this.Controls.Add(this.label1);
-      this.Controls.Add(this.linkLabel);
-      this.Controls.Add(this.okButton);
-      this.Controls.Add(this.iconLabel);
-      this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
-      this.Icon = global::HeuristicLab.PluginInfrastructure.Resources.HeuristicLab;
-      this.MaximizeBox = false;
-      this.MinimizeBox = false;
-      this.Name = "FrameworkVersionWarning";
-      this.ShowInTaskbar = false;
-      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
-      this.Text = "Warning";
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.Label iconLabel;
-    private System.Windows.Forms.Button okButton;
-    private System.Windows.Forms.LinkLabel linkLabel;
-    private System.Windows.Forms.Label label1;
-  }
-}
Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/ErrorHandling/FrameworkVersionWarning.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/ErrorHandling/FrameworkVersionWarning.cs	(revision 5984)
+++ 	(revision )
@@ -1,42 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
-	 * (at your option) any later version.
-	 *
-	 * HeuristicLab is distributed in the hope that it will be useful,
-	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
-	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-	 * GNU General Public License for more details.
-	 *
-	 * You should have received a copy of the GNU General Public License
-	 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
-	 */
-#endregion
-using System;
-using System.Windows.Forms;
-
-namespace HeuristicLab.PluginInfrastructure {
-  public partial class FrameworkVersionWarning : Form {
-    public FrameworkVersionWarning() {
-      InitializeComponent();
-    }
-
-    private void linkLabel_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e) {
-      try {
-        System.Diagnostics.Process.Start("http://www.microsoft.com/downloads/en/details.aspx?displaylang=en&FamilyID=0a391abd-25c1-4fc0-919f-b21f31ab88b7");
-        linkLabel.LinkVisited = true;
-      }
-      catch (Exception) { }
-    }
-
-    private void cancelButton_Click(object sender, EventArgs e) {
-      Application.Exit();
-    }
-  }
-}
Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj	(revision 5984)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj	(revision 5997)
@@ -221,10 +221,4 @@
     <Compile Include="BaseClasses\PluginBase.cs" />
     <Compile Include="DefaultApplicationManager.cs" />
-    <Compile Include="ErrorHandling\FrameworkVersionWarning.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="ErrorHandling\FrameworkVersionWarning.Designer.cs">
-      <DependentUpon>FrameworkVersionWarning.cs</DependentUpon>
-    </Compile>
     <Compile Include="ErrorHandling\ErrorDialog.cs">
       <SubType>Form</SubType>
@@ -234,4 +228,10 @@
     </Compile>
     <Compile Include="ErrorHandling\ErrorHandling.cs">
+    </Compile>
+    <Compile Include="ErrorHandling\FrameworkVersionErrorDialog.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="ErrorHandling\FrameworkVersionErrorDialog.Designer.cs">
+      <DependentUpon>FrameworkVersionErrorDialog.cs</DependentUpon>
     </Compile>
     <Compile Include="LightweightApplicationManager.cs" />
Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/Main.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/Main.cs	(revision 5984)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/3.3/Main.cs	(revision 5997)
@@ -34,9 +34,8 @@
     /// <param name="args">Command line arguments</param>
     public static void Run(string[] args) {
-      bool fullProfileInstalled = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("Software\\Microsoft\\NET Framework Setup\\NDP\\v4\\Full") != null;
-      if (!fullProfileInstalled) {
+      if (!FrameworkVersionErrorDialog.NET4FullProfileInstalled) {
         Application.EnableVisualStyles();
         Application.SetCompatibleTextRenderingDefault(false);
-        Application.Run(new FrameworkVersionWarning());
+        Application.Run(new FrameworkVersionErrorDialog());
       } else {
         try {